import java.net.*;
import java.io.*;
import java.util.Date;

/*
 -p port for this proxy
 
 -r remote port for direct mode
 -d remote address for direct mode
 -f username/hostname separator string
 -b Bindaddress
 -m Maxclients

 -s secured mode

*/

public final class pop3proxy
{
  private transient ServerSocket server;
  public static int MAXPOP3PROXYCLIENTS=10; // prevent overload by cdrop attacks
  public final static String VERSION="0.3";  
  public static InetAddress targetserver;
  public static int targetport=110;
  public static String separator="#";
  public static boolean secured=false;
  
public static final void main(String argv[]) throws IOException
{
 int port=110;
 InetAddress adr=null;
  
 for(int i=0;i<argv.length;i++)
 {
  String a;
  a=argv[i];
  if(a.startsWith("-")) 
   {
    if(a.equalsIgnoreCase("-p")) { 
                                   i++;
                                   port=parseNum(argv,i,port);
                                   continue;
                                 }
   
    if(a.equalsIgnoreCase("-r")) { 
                                   i++;
                                   targetport=parseNum(argv,i,targetport);
                                   continue;
                                 }
   if(a.equalsIgnoreCase("-m")) {
                                  i++;
                                  MAXPOP3PROXYCLIENTS=parseNum(argv,i,MAXPOP3PROXYCLIENTS);
 
                                 }
                                 
    if(a.equalsIgnoreCase("-d")) { 
                                   i++;
                                   String hname="";
                                   hname=parseStr(argv,i,hname);
                                   if(hname.length()==0) continue;
                                   try
                                    {
                                     targetserver=InetAddress.getByName(hname);
                                    }
                                   catch (IOException badname)
                                    {
                                     System.err.println("[POP3PROXY] Host not found: "+hname);
                                    }
                                   continue;
                                 }

    if(a.equalsIgnoreCase("-b")) { 
                                   i++;
                                   String hname="";
                                   hname=parseStr(argv,i,hname);
                                   if(hname.length()==0) continue;
                                   try
                                    {
                                     adr=InetAddress.getByName(hname);
                                    }
                                   catch (IOException badname)
                                    {
                                     System.err.println("[POP3PROXY] BindAddress Host not found: "+hname);
                                    }
                                   continue;
                                 }
                                 
    if(a.equalsIgnoreCase("-f")) { 
                                   i++;
                                   separator=parseStr(argv,i,separator);
                                   continue;
                                 }
    if(a.equalsIgnoreCase("-s"))
                                {
                                  secured=true;
                                  continue;
                                }
                                 
    System.err.println("[POP3PROXY] Unknown switch "+a);
    continue;
   }
  System.err.println("[POP3PROXY] Argument "+a+" doesn't follows any switch.");
 }
 new pop3proxy(port,adr).loop();
}

pop3proxy(int port,InetAddress adr) throws IOException
{
 if(adr!=null)
 
  try{
  server=new ServerSocket(port,10,adr);
  }
  catch(IOException e) {System.err.println("[POP3PROXY] Cannot bind to my port "+port+"/"+adr.getHostAddress());throw e;}
   else
  try{
    server=new ServerSocket(port);
  }
  catch(IOException e) {System.err.println("[POP3PROXY] Cannot bind to my port "+port+"/*");throw e;}
   
}

private final void loop()
 {
  ThreadGroup clients;
  pop3proxyworker client;
  clients=new ThreadGroup("POP3PROXY-clients");
//  clients.setDaemon(true);
   while (true ) {
            Socket clientSocket = null;
            client=null;
            try {
                clientSocket = server.accept();
                } catch (IOException e) {
                System.err.println("[POP3PROXY] Accept failed: "+e);
                continue;
            }
            if(clients.activeCount()>MAXPOP3PROXYCLIENTS) 
              try {
              System.err.println(new Date()+" [POP3PROXY] Active clients limit ("+MAXPOP3PROXYCLIENTS+") reached, kicking off.");
              clientSocket.close();}
              catch(IOException e) {}
              finally { continue;}
            client=new pop3proxyworker(clientSocket);
            new Thread(clients,client).start();
   }  /* listen */
   
 }
 
 private final static int parseNum(String argv[],int idx,int oldvalue)
 {
   if(idx>=argv.length) return oldvalue;
   int newval=oldvalue;
   try
    {
     newval=Integer.valueOf(argv[idx]).intValue();
    }
   catch (Exception e)
    { 
      System.err.println("[POP3PROXY] Not a number "+argv[idx]);
    }
    return newval;
 }
 
 private final static String parseStr(String argv[],int idx,String oldvalue)
 {
   if(idx>=argv.length) return oldvalue;
   if(argv[idx].startsWith("-")) return oldvalue;
   return argv[idx];
 }
 
}
