import java.io.*;
import java.net.*;
import java.text.*;
import java.util.*;


public final class pop3proxyworker implements Runnable
{
 private Socket client;
 
pop3proxyworker(Socket cl)
{
 client=cl;
}

public final void run()
{
 DataInputStream dis;
 DataOutputStream dos;
 DataInputStream sis=null;
 DataOutputStream sos=null;
 
 Socket out=null;
 boolean connected=false;
 try
 {
 dis=new DataInputStream(client.getInputStream());
 dos=new DataOutputStream( new BufferedOutputStream (
     client.getOutputStream(),1500)); 
 }
 catch (IOException ioe)
  {
       close();return;
  }
     
 // INITIALIZE
 if(pop3proxy.targetserver!=null)
  {
   try
   {
    out=new Socket(pop3proxy.targetserver,pop3proxy.targetport);
    sis=new DataInputStream(new BufferedInputStream(
        out.getInputStream(),1500));
    sos=new DataOutputStream( new BufferedOutputStream (
        out.getOutputStream(),1500)); 
    dos.writeBytes("+OK Java POP3 proxy "+pop3proxy.VERSION+" gateway: ");
    dos.writeBytes(sis.readLine()+"\r\n");
    dos.flush();
   }
   catch (IOException grrr)
   {
    try
    {
      dos.writeBytes("-ERR Target server is not online. Service unavailable.\r\n");
      dos.close();
    }
    catch (IOException grrrf) {}
    finally
     { close();return;}
    
   }
   connected=true;
  } else
  {
   try
   {
    send("+OK Java POP3 proxy "+pop3proxy.VERSION+" ready. Hare Krishna.",dos);
   }
   catch (IOException grrrf) { close();return;}
  }
  
  mainloop:while(true)
  {
   try
   {
     String req,com;
     StringTokenizer st;
     req=dis.readLine();
     if(req==null) break;
     st=new StringTokenizer(req);
     if(!st.hasMoreTokens()) { send("-ERR No command entered.",dos);continue;}
     if(pop3proxy.secured)
       if(req.length()>4+1+4+1+40+1+40)
       {
        send("-ERR POP3 Protocol violation (request too long) is not allowed in secure proxy mode.",dos);
	continue;
       } else
       {
        //arg size scan
	while(st.hasMoreTokens())
	 if(st.nextToken().length()>40)
	   {
	    send("-ERR POP3 Protocol violation (argument too long) is not allowed in secure proxy mode.",dos);
            continue mainloop;
           }
	st=new StringTokenizer(req);
       } // secured check
     com=st.nextToken().toUpperCase();
     
     if(com.equals("QUIT"))
      {
       if(connected) { send("QUIT",sos);
                       sos.close();
                       connected=false;
                       send("+OK Proxy connection sucessfully closed. Love God.",dos);
                       close();
                       return;
                     }
       send("+OK Nice to talk with you",dos);
       close();
       return;
      }
     if(com.equals("APOP"))
       if(pop3proxy.targetserver!=null)
        {
          send(req,sos);
          checkReply(sis.readLine(),dos);	
	  continue;
       }else
       { 
          send("-ERR Not possible when in multi-host mode. If you really need APOP authorization, switch pop3proxy to direct mode.",dos);
          continue;
       }
       
       if(com.equals("USER"))
        {
	   if(pop3proxy.targetserver!=null)
	    {
	     send(req,sos);
	     checkReply(sis.readLine(),dos);
	     continue;
	    }
           if(!st.hasMoreTokens())
           {
             send("-ERR Missing argument. Syntax: USER username"+pop3proxy.separator+"hostname.",dos);
             continue;
           }
           req=st.nextToken();
           if(req.indexOf(pop3proxy.separator)==-1)
           {
             send("-ERR missing hostname. Switch proxy to direct mode or change username in your POP3 client to username"+pop3proxy.separator+"hostname.",dos);
             continue;
           }
           try
           {
	     if(connected) 
	        try
		 {
		  out.close();
		 }
		 catch (IOException ignore) {}
		 finally
		 {
		  connected=false;
		 }
             InetAddress target=InetAddress.getByName(req.substring(1+req.indexOf(pop3proxy.separator)));
             //connect!
             out=new Socket(target,pop3proxy.targetport);
             
             sis=new DataInputStream(new BufferedInputStream(
                out.getInputStream(),1500));
             sos=new DataOutputStream( new BufferedOutputStream (
                out.getOutputStream(),1500)); 
                
             sis.readLine(); // read greet msg.
             send("USER "+req.substring(0,req.indexOf(pop3proxy.separator)),sos);
             send(sis.readLine(),dos);
             connected=true;
             continue;
           }
           catch (UnknownHostException hnf)
            {
             send("-ERR Host not found. If hostname is good, use IP address for avoiding Java DNS caching bug/feature.",dos);
             continue;
            }
           catch (ConnectException cn)
            {
             send("-ERR Connection refused by POP3 host. Are you on line?",dos);
             continue;
            }
           catch (IOException cn)
            {
             send("-ERR I/O error when contacting POP3 host. Try again.",dos);
             continue;
            }
            
        }

      
     if(!connected)
     {
       send("-ERR Open proxy connection with USER command first or use QUIT to terminate session.",dos);
       continue;
     } /* not connected! */
     
     
     
    //send request to remote server
    // send(req,sos);

    //get reply
    
    // RETR and TOP have allways multi-line reply
    if(
       com.equals("RETR")||
       com.equals("TOP") 
      )
      {
       send(req,sos);
       readMultiline(sis,dos);
       continue;
      }
    // UIDL,EUIDL and LIST without args have also multi-line reply
    if(
        (
         com.equals("LIST")|| 
         com.equals("UIDL")||
	 com.equals("EUIDL")
        )
         && !st.hasMoreTokens())
     {
       send(req,sos);
       readMultiline(sis,dos);
       continue;
     }
    if(com.equals("XTND"))
     {
       // special commands
       try
        {
          com=st.nextToken().toUpperCase();
        }
      catch (NoSuchElementException nse)
       {
         // XTND without any args
         send("-ERR XTND Needs at least one argument.",dos);
         continue;
       }
       if(com.equals("XLST"))
          {
	    send(req,sos);
            readMultiline(sis,dos);
            continue;
          }
      if(com.equals("XMIT"))
        {
          String tmp;
	  send(req,sos);
          tmp=sis.readLine();
          send(tmp,dos);
          if(tmp.startsWith("-ERR"))
           {
            continue;
           }
          // read input until .
          while(true)
          {
            tmp=dis.readLine();
            if(tmp==null) throw new EOFException();
            sos.writeBytes(tmp);
            sos.writeBytes("\r\n");
            if(tmp.equals(".")) break;
          }
          sos.flush();
          send(sis.readLine(),dos);
          continue; 
        }
      send("-ERR Unknown XTND command "+com+". Send command description to Java POP3PROXY author.",dos);
      continue;
     }	
    if(pop3proxy.secured) 
        {
	 if(com.equals("STAT")||
	   com.equals("DELE")||
	   com.equals("NOOP")||
	   com.equals("RSET")||
	   com.equals("PASS")
	   )
           {
             send(req,sos);
             checkReply(sis.readLine(),dos);
             continue;
           }
	 send("-ERR Gatewaying of unknown commands is not allowed in secure mode.",dos);
	 continue;
	}	
    else     
     {
      // all other has single line reply
      send(req,sos);
      send(sis.readLine(),dos);
     }
   }
   catch (IOException z)
   {
    if(connected)
     try
      {
       out.close();
      }
     catch (IOException z2) {}
     
    close();return;
   }
  }
  
}

private final void close()
{
   try
   {
     client.close();
   }
   catch (IOException ignore) {}
   finally
   {
       client=null;
       return;
   }
}

private final static void send(String msg,DataOutputStream d) throws IOException
{
 d.writeBytes(msg);
 d.writeBytes("\r\n");
 d.flush();
}

private final static void checkReply(String s,DataOutputStream d) throws IOException
{
 if(s==null) throw new EOFException();
 if(s.startsWith("+OK") ||
    s.startsWith("-ERR")) { send(s,d);return;}
    
 send("-ERR POP3 Protocol violation (bad reply from server) is not allowed in secure proxy mode.",d);
 throw new EOFException("Protocol VIOLATED!");
 
}
private final static void readMultiline(DataInputStream di,DataOutputStream d) throws IOException
{
 String x;
 x=di.readLine();
 if(x==null) throw new EOFException(); 
 if(x.startsWith("-ERR")) { send(x,d);return;}
  else
   if(pop3proxy.secured && !x.startsWith("+OK"))
    {
     send("-ERR POP3 Protocol violation (bad reply from server) is not allowed in secure proxy mode.",d);
     throw new EOFException("Protocol VIOLATED!");
    }
 d.writeBytes(x);
 d.writeBytes("\r\n");  
 
 while(true)
 {
  x=di.readLine();
  if(x==null) throw new EOFException();
  d.writeBytes(x);
  d.writeBytes("\r\n");  
  if(x.equals(".")) break;
 }
 d.flush();
}

}
